#!/bin/bash
# /opt/local/bin/psave2adrv-0.2.sh -- Version bilingue FR-EN | Bilingual (EN-FR) version --
# Alternately, you can save this script in: | À la place, vous pouvez enregistrer ce script dans :
# /root/my-applications/bin/psave2adrv-0.2.sh
#
# Thanks to augras for his tests. | Merci à augras pour ses tests.
#
########## # Usage: (EN)
# First, enter the directory where your Pup is located and open a terminal there.
# Then type: psave2adrv.sh name-and-version-of-your-Pup
#
# Example: psave2adrv-0.2.sh xenial_7.0.6
# You have to change this variable to match the Pup's name and version.
#
########## # Usage : (FR)
# D'abord entrer dans le répertoire où se trouve votre Puppy et y ouvrir une console.
# Puis taper : psave2adrv-0.2.sh nom-et-version-de-votre-Puppy
#
# Exemple : psave2adrv-0.2.sh xenial_7.0.6
# Vous devez changer cette variable pour qu'elle corresponde au nom et à la version du Puppy.
####
# © musher0, 2018-03-31. GPL3 # Please see: https://opensource.org/licenses/GPL-3.0.
##########
#    Ce programme est libre : vous pouvez le redistribuer ou modifier selon les termes de la
#   Licence Publique Générale GNU publiée par la Free Software Foundation (v. 3 ou toute
#   version ultérieure choisie par vous).
#         Ce programme est distribué dans l'espoir qu'il sera utile, mais SANS AUCUNE
#   GARANTIE, ni explicite ni implicite, y compris des garanties de commercialisation ou
#   d'adaptation à un but spécifique. Pour obtenir plus     de détails, veuillez vous reporter au
#   texte de cette licence à https://opensource.org/licenses/GPL-3.0 pour le texte officiel, à
#    http://www.linux-france.org/article/these/gpl.html pour une traduction et à
#    https://fr.wikipedia.org/wiki/Licence_publique_générale_GNU pour une explication en français.
################
#### set -xe
# LANGVx="$LANG";LANG=en_CA # For tests. | Pour les tests.
clear
case "${LANG:0:2}" in
      fr)echo -e "\t\e[33m\e[4m\e[1mConvertisseur de pupsave en adrv_xxx.sfs,\e[24m
               par musher0, 2018-04-13.\e[0m" ;;
      en|*)echo -e "\t\e[33m\e[4m\e[1mPupsave to adrv_xxx.sfs Converter,\e[24m
               by  musher0, 2018-04-13.\e[0m" ;;
esac

if [ "$1" = "" ];then
     case "${LANG:0:2}" in
          fr) echo -e "\n     \e[33m\e[4mVeuillez redémarrer avec le nom et la version de\e[24m
     \e[4mvotre Puppy comme 1er paramètre après la commande.\e[24m
          Par ex. :      psave2adrv.sh \e[4mxenial_7.0.6\e[0m\n" ;;
          en|*) echo -e "\n\t\e[33m\e[4mPlease restart with the name and version of\e[24m
     \e[4myour Pup as the first parameter after the command.\e[24m
          E.g.:      psave2adrv.sh \e[4mxenial_7.0.6\e[0m\n" ;;
      esac
     exit
fi

# Vérifier si on a assez de mémoire vive
ls -1 /initrd | grep pup > liste1
>liste2
while read line
     do du -h -c /initrd/$line | grep total | awk '$1 ~ /M/ {print $1}' >> liste2
done < liste1

Tot=0
while read line;do # on additionne | we add
     Tot="`expr $Tot + "${line%M*}"`"
done < liste2
MEV="`free -m | awk '$1 ~ /Mem/ { print $2}'`"
if [ "$MEV" -gt "$Tot" ];then
     case "${LANG:0:2}" in
          fr)echo -e "\n\e[33m\e[4mVous avez assez de MEV ($MEV Mo).\e[0m"
          ;;
          en|*)echo -e "\n\e[33m\e[4mYou have enough RAM ($MEV Mo)."
          ;;
     esac
else
     case "${LANG:0:2}" in
          fr)echo -e "\n\e[33m\e[4mVous n'avez pas assez de MEV ($MEV Mo). On ne peut continuer.\e[0m" ;;
          en|*)echo -e "\n\e[33m\e[4mYou do not have enough RAM ($MEV Mb). We cannot continue." ;;
     esac;exit
fi
# Calcul probablement conservateur, mais empêchera les mauvaises surprises.
# Probably conservative calculation, but will prevent bad surprises.
rm -f liste1;rm -f liste2

ReceivingArch="adrv_$1-bis"
REP="`awk -F"'" '$1 ~ /PUPSFS/ { print $2}' /etc/rc.d/PUPSTATE | awk -F"," '{ print "/mnt/"$1$3}'`"
REP="`dirname $REP`"

cd "$REP" # construction de l'archive squash.
if [ -f $ReceivingArch.sfs ];then # Precaution
     case "${LANG:0:2}" in fr) echo -e "\n\e[33m\e[4mSi on continue, l'archive $ReceivingArch.sfs\e[24m
     \e[4mexistante sera détruite (effacée). -- Ça va ? --\e[24m
\e[7m\e[4mTaper 'n' ou 'N' quitte; toute autre touche continue.\e[0m\n" ;;
          en|*) echo -e "
     \e[33m\e[4mIf we continue, the existing $ReceivingArch.sfs\e[24m
     \e[4mfile will be destroyed (erased). -- Is this ok? --\e[24m
\e[7m\e[4mType 'n' or 'N' to exit; any other key to continue.\e[0m\n" ;;
     esac
     read Answer1
     case "$Answer1" in n|N)exit ;;
     esac
fi

mksquashfs /initrd/pup_rw/ ./$ReceivingArch.sfs -noappend -all-root -b 1048576 -comp xz -Xdict-size 100% > mksfs.rpt &
# The last part of this line < -b 104... etc. > insure pretty much maximum compression
# of the sfs archive. It takes a couple of minutes, depending on the size of the pupsave file.

# La dernière partie de cette ligne < -b 104... etc. > assure une compression quasi maximale
# de l'archive sfs. Cela prend +/- deux minutes, selon la taille du pupsave.
      # Pour voir les détails de l'opération, s.v.p. ouvrir le fichier texte mksquashfs.rpt dans votre éditeur ou lisez-le avec more.
      # To see the details of the operation, please open the mksquashfs.rpt text file in your editor or read it with more.
      while pgrep mksquashfs &> /dev/null;do
          echo -en "\e[34m.";sleep 0.5
      # Source de cette barre : réponse no 0 par « purushothaman poovai » à https://
# stackoverflow.com/questions/238073/how-to-add-a-progress-bar-to-a-shell-script#238094
     done
case "${LANG:0:2}" in fr)echo -e "\n     \e[33m\e[4mC'est fait!\e[24m
\t \e[4mVeuillez redémarrer pour activer votre nouvel adrv.\e[24m
\t\e[7m\e[4mImportant -- \e[4mVeuillez ne pas charger le pupsave qui a \e[24m\e[27m
\t\e[7m\e[4mservi de base à l'adrv, pour éviter les dédoublements.\e[0m" ;;
     en|*)echo -e "\n     \e[33m\e[4mDone!\e[24m
\t\e[4mYou should now reboot to activate your new adrv sfs.\e[24m
\t \e[7m\e[4mImportant -- \e[4mMake sure to store ALL pupsave files\e[24m\e[27m
\t     \e[7m\e[4mOUT OF THE WAY to be able to start afresh.\e[0m\n" ;;
esac
# LANG="$LANGVx" # For tests. | Pour les tests. # set +xe
exit

